# cs_ip_address – Manages public IP address associations on Apache CloudStack based clouds

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Acquires and associates a public IP to an account or project.

- Due to API limitations this is not an idempotent call, so be sure to only conditionally call this when state=present.

- Tagging the IP address can also make the call idempotent.

## Requirements

The below requirements are needed on the host that executes this module.

- python >= 2.6

- cs >= 0.6.10

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
account string |  | Account the IP address is related to.

api_http_method
string

Choices:
- get
- post

HTTP method used to query the API endpoint.
If not given, the `CLOUDSTACK_METHOD` env variable is considered.
As the last option, the value is taken from the ini config file, also see the notes.
Fallback value is `get` if not specified.

api_key string |  | API key of the CloudStack API. If not given, the `CLOUDSTACK_KEY` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
api_region string | Default: "cloudstack" | Name of the ini section in the `cloustack.ini` file. If not given, the `CLOUDSTACK_REGION` env variable is considered.
api_secret string |  | Secret key of the CloudStack API. If not set, the `CLOUDSTACK_SECRET` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
api_timeout integer |  | HTTP timeout in seconds. If not given, the `CLOUDSTACK_TIMEOUT` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes. Fallback value is 10 seconds if not specified.
api_url string |  | URL of the CloudStack API e.g. https://cloud.example.com/client/api. If not given, the `CLOUDSTACK_ENDPOINT` env variable is considered. As the last option, the value is taken from the ini config file, also see the notes.
domain string |  | Domain the IP address is related to.
ip_address string |  | Public IP address. Required if state=absent and tags is not set.
network string |  | Network the IP address is related to. Mutually exclusive with vpc.

poll_async
boolean

Choices:
- no
- yes ←

Poll async jobs until job has finished.

project string |  | Name of the project the IP address is related to.

state
string

Choices:
- present ←
- absent

State of the IP address.

tags list added in 2.6 |  | List of tags. Tags are a list of dictionaries having keys key and value. Tags can be used as an unique identifier for the IP Addresses. In this case, at least one of them must be unique to ensure idempotency. aliases: tag
vpc string |  | VPC the IP address is related to. Mutually exclusive with network.
zone string |  | Name of the zone in which the IP address is in. If not set, default zone is used.

## Notes

Note

- Ansible uses the `cs` library’s configuration method if credentials are not provided by the arguments `api_url`, `api_key`, `api_secret`. Configuration is read from several locations, in the following order. The `CLOUDSTACK_ENDPOINT`, `CLOUDSTACK_KEY`, `CLOUDSTACK_SECRET` and `CLOUDSTACK_METHOD`. `CLOUDSTACK_TIMEOUT` environment variables. A `CLOUDSTACK_CONFIG` environment variable pointing to an `.ini` file. A `cloudstack.ini` file in the current working directory. A `.cloudstack.ini` file in the users home directory. Optionally multiple credentials and endpoints can be specified using ini sections in `cloudstack.ini`. Use the argument `api_region` to select the section name, default section is `cloudstack`. See https://github.com/exoscale/cs for more information.

- A detailed guide about cloudstack modules can be found in the CloudStack Cloud Guide.

- This module supports check mode.

## Examples

    - name: Associate an IP address conditionally
      cs_ip_address:
        network: My Network
      register: ip_address
      when: instance.public_ip is undefined
      delegate_to: localhost

    - name: Disassociate an IP address
      cs_ip_address:
        ip_address: 1.2.3.4
        state: absent
      delegate_to: localhost

    - name: Associate an IP address with tags
      cs_ip_address:
        network: My Network
        tags:
          - key: myCustomID
          - value: 5510c31a-416e-11e8-9013-02000a6b00bf
      register: ip_address
      delegate_to: localhost

    - name: Disassociate an IP address with tags
      cs_ip_address:
        state: absent
        tags:
          - key: myCustomID
          - value: 5510c31a-416e-11e8-9013-02000a6b00bf
      delegate_to: localhost

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
account string | success | Account the IP address is related to. Sample: example account
domain string | success | Domain the IP address is related to. Sample: example domain
id string | success | UUID of the Public IP address. Sample: a6f7a5fc-43f8-11e5-a151-feff819cdc9f
ip_address string | success | Public IP address. Sample: 1.2.3.4
project string | success | Name of project the IP address is related to. Sample: Production
tags dictionary added in 2.6 | success | List of resource tags associated with the IP address. Sample: [ { "key": "myCustomID", "value": "5510c31a-416e-11e8-9013-02000a6b00bf" } ]
zone string | success | Name of zone the IP address is related to. Sample: ch-gva-2

## Status

- This module is guaranteed to have backward compatible interface changes going forward. [stableinterface]

- This module is maintained by the Ansible Community. [community]

### Authors

- Darren Worrall (@dazworrall)

- René Moser (@resmo)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.